# Uses of Interface
net.shibboleth.idp.attribute.resolver.AttributeDefinition

Packages that use AttributeDefinition
Package
Description
net.shibboleth.idp.attribute.resolver
A system which is capable of retrieving a collection of `IdPAttribute`s from a variety of locations, transform them, and associate a set of protocol-specific encoders to them.
net.shibboleth.idp.attribute.resolver.ad.impl
Implementations of various `AttributeDefinition`s.
net.shibboleth.idp.attribute.resolver.ad.mapped.impl
A `DataConnector` implementation that maps from a given set of source value to an output value.
net.shibboleth.idp.attribute.resolver.context
The context to do with Attribute Resolution.
net.shibboleth.idp.attribute.resolver.impl
Implementations of core resolver functionality.
net.shibboleth.idp.attribute.resolver.testing
Testing utility classes.
net.shibboleth.idp.saml.attribute.resolver.impl
Implementations of SAML related `AttributeDefinition` and `DataConnector`.

## Uses of AttributeDefinition in net.shibboleth.idp.attribute.resolver

Classes in net.shibboleth.idp.attribute.resolver that implement AttributeDefinition
Modifier and Type
Class
Description
`class`
`AbstractAttributeDefinition`
Base class for attribute definition resolver plugins.
`final class`
`ResolvedAttributeDefinition`
A proxy which wraps a resolved attribute definition and always returns the same attribute.
Fields in net.shibboleth.idp.attribute.resolver declared as AttributeDefinition
Modifier and Type
Field
Description
`private final AttributeDefinition`
ResolvedAttributeDefinition.`resolvedDefinition`
The attribute definition that was resolved to produce the attribute.
Methods in net.shibboleth.idp.attribute.resolver that return AttributeDefinition
Modifier and Type
Method
Description
`AttributeDefinition`
ResolvedAttributeDefinition.`getResolvedDefinition()`
Gets the wrapped attribute definition that was resolved.
Constructors in net.shibboleth.idp.attribute.resolver with parameters of type AttributeDefinition
Modifier
Constructor
Description
``
`ResolvedAttributeDefinition(AttributeDefinition definition, IdPAttribute attribute)`
Constructor.

## Uses of AttributeDefinition in net.shibboleth.idp.attribute.resolver.ad.impl

Classes in net.shibboleth.idp.attribute.resolver.ad.impl that implement AttributeDefinition
Modifier and Type
Class
Description
`class`
`ContextDerivedAttributeDefinition`
An attribute definition which returns an attribute whose values are derived from the `ProfileRequestContext` associated with the request via a plugged in `Function`.
`class`
`DateTimeAttributeDefinition`
An `AttributeDefinition` that creates an attribute whose values are the values of all its dependencies, passed through or converted into a `DateTimeAttributeValue`.
`class`
`DecryptedAttributeDefinition`
An `AttributeDefinition` that creates an attribute whose values are the decrypted values of its dependencies.
`class`
`PrescopedAttributeDefinition`
An attribute definition that creates `ScopedStringAttributeValue`s by taking a source attribute value splitting it at a delimiter.
`class`
`PrincipalNameAttributeDefinition`
An attribute definition which returns an attribute with a single value - the principal.
`class`
`RegexSplitAttributeDefinition`
An `AttributeDefinition` that produces its attribute values by taking the first group match of a regular expression evaluating against the values of this definition's dependencies.
`class`
`ScopedAttributeDefinition`
An attribute definition that creates `ScopedStringAttributeValue`s by taking a source attribute value and applying a static scope to each.
`class`
`ScriptedAttributeDefinition`
An `AttributeDefinition` that executes a script in order to populate the values of the generated attribute.
`class`
`SimpleAttributeDefinition`
An `AttributeDefinition` that creates an attribute whose values are the values of all its dependencies.
`class`
`StaticAttributeDefinition`
An attribute definition that simply returns a static value.
`class`
`TemplateAttributeDefinition`
An attribute definition that constructs its values based on the values of its dependencies using the Velocity Template Language.

## Uses of AttributeDefinition in net.shibboleth.idp.attribute.resolver.ad.mapped.impl

Classes in net.shibboleth.idp.attribute.resolver.ad.mapped.impl that implement AttributeDefinition
Modifier and Type
Class
Description
`class`
`MappedAttributeDefinition`
Implementation of Mapped Attributes.

## Uses of AttributeDefinition in net.shibboleth.idp.attribute.resolver.context

Methods in net.shibboleth.idp.attribute.resolver.context with parameters of type AttributeDefinition
Modifier and Type
Method
Description
`void`
AttributeResolverWorkContext.`recordAttributeDefinitionResolution(AttributeDefinition definition, IdPAttribute attribute)`
Records the results of an attribute definition resolution.

## Uses of AttributeDefinition in net.shibboleth.idp.attribute.resolver.impl

Fields in net.shibboleth.idp.attribute.resolver.impl with type parameters of type AttributeDefinition
Modifier and Type
Field
Description
`private Map<String,AttributeDefinition>`
AttributeResolverImpl.`attributeDefinitions`
Attribute definitions defined for this resolver.
Methods in net.shibboleth.idp.attribute.resolver.impl that return types with arguments of type AttributeDefinition
Modifier and Type
Method
Description
`Map<String,AttributeDefinition>`
AttributeResolverImpl.`getAttributeDefinitions()`
Gets the collection of attribute definitions for this resolver.
Method parameters in net.shibboleth.idp.attribute.resolver.impl with type arguments of type AttributeDefinition
Modifier and Type
Method
Description
`void`
AttributeResolverImpl.`setAttributeDefinitions(Collection<AttributeDefinition> definitions)`
Sets the attribute definitions for this resolver.

## Uses of AttributeDefinition in net.shibboleth.idp.attribute.resolver.testing

Classes in net.shibboleth.idp.attribute.resolver.testing that implement AttributeDefinition
Modifier and Type
Class
Description
`class`
`MockAttributeDefinition`
An attribute definition that simply returns a static value.
`class`
`MockStaticAttributeDefinition`
An attribute definition that simply returns a static value.
`private static class`
`TestSources.StaticAttributeDefinition`
Helper class.
Methods in net.shibboleth.idp.attribute.resolver.testing that return AttributeDefinition
Modifier and Type
Method
Description
`static AttributeDefinition`
TestSources.`populatedStaticAttribute()`
Create a static attribute with known values.
`static AttributeDefinition`
TestSources.`populatedStaticAttribute(String attributeName, int attributeValuesCount)`
return an `AttributeDefinition` with static contents
`static AttributeDefinition`
TestSources.`populatedStaticAttribute(IdPAttribute attribute)`
Create a static attribute with known attribute.

## Uses of AttributeDefinition in net.shibboleth.idp.saml.attribute.resolver.impl

Classes in net.shibboleth.idp.saml.attribute.resolver.impl that implement AttributeDefinition
Modifier and Type
Class
Description
`class`
`SAML1NameIdentifierAttributeDefinition`
Deprecated, for removal: This API element is subject to removal in a future version.
`class`
`SAML2NameIDAttributeDefinition`
Deprecated, for removal: This API element is subject to removal in a future version.